/**********************************************************************************/
/*                                                                                */
/*    Copyright (C) 2005 OLIMEX  LTD.                                             */
/*                                                                                */
/*    Module Name    :  mma module                                                */
/*    File   Name    :  mma.h                                                     */
/*    Revision       :  01.00                                                     */
/*    Date           :  2006/10/05 initial version                                */
/*                                                                                */
/**********************************************************************************/

/****************************************************************************/
/*  Init MMA7620Q Device                                                    */
/*  Function : InitMMA                                                      */
/*      Parameters                                                          */
/*          Input   :  Nothing                                              */
/*          Output  :  Nothing                                              */
/****************************************************************************/
void InitMMA(void);

/****************************************************************************/
/*  Get MMA coordinates (X,Y,Z)                                             */
/*  Function : GetCoordinates                                               */
/*      Parameters                                                          */
/*          Input   :  Nothing                                              */
/*          Output  :  Nothing                                              */
/****************************************************************************/
void GetCoordinates (void);

/****************************************************************************/
/*  Init ADC12 module                                                       */
/*  Function : InitADC12                                                    */
/*      Parameters                                                          */
/*          Input   :  Nothing                                              */
/*          Output  :  Nothing                                              */
/****************************************************************************/
void InitADC12(void);

/****************************************************************************/
/*  Get value form ADC12 chanel A11 (measure VCC)                           */
/*  Function : GetADC12_A11                                                 */
/*      Parameters                                                          */
/*          Input   :  Nothing                                              */
/*          Output  :  maesured value                                       */
/****************************************************************************/
unsigned int MeasureHalfVCC(void);




